/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.11 by edhill, Fri Oct 10 03:29:44 2003 UTC revision 1.45 by edhill, Sat Jul 17 02:08:45 2004 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  #  $Header$  #  $Header$
4  #  $Name$  #  $Name$
# Line 13  usage() Line 13  usage()
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mpi)                   use MPI input files"      echo "  (-mpi)                   use MPI input files"
15      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
16        echo "                             (DEF=\"-ieee\")"
17      echo "  (-optfile=|-of=)STRING   list of optfiles to use"      echo "  (-optfile=|-of=)STRING   list of optfiles to use"
18      echo "  (-a|-addr)STRING         list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
19      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"edhill@mitgcm.org\")"
20      echo "  (-t|-tdir)STRING         list of test dirs to use"      echo "  (-t|-tdir) STRING        list of test dirs to use"
21      echo "                             (DEF=\"\" which builds all)"      echo "                             (DEF=\"\" which builds all)"
22      echo "  (-b|-bash)STRING         location of \"bash\" executable"      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"
23      echo "                             (DEF=\"\" for \"/bin/bash\")"      echo "                             Bourne-compatible \"sh\" shell"
24      echo "  (-command)STRING         command to run"      echo "                             (DEF=\"\" for \"bash\")"
25        echo "  (-adm|-ad)               perform an adjoint run"
26        echo "  (-command) STRING        command to run"
27      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
28      echo "  (-m|-make)STRING         command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
29      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
30        echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
31      echo "  (-clean)                 *ONLY* run \"make CLEAN\""      echo "  (-clean)                 *ONLY* run \"make CLEAN\""
32      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
33      echo "  (-nogenmake|-ng)         skip the genmake stage"      echo "  (-nogenmake|-ng)         skip the genmake stage"
34      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
35      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"
36        echo "  (-deldir|-dd)            on success, delete the output directory"
37      echo      echo
38      echo "and where STRING follows a whitespace-delimited format"      echo "and where STRING follows a whitespace-delimited format"
39      echo "such as:"      echo "such as:"
# Line 41  usage() Line 46  usage()
46  #  build the mpack utility  #  build the mpack utility
47  build_mpack()  build_mpack()
48  {  {
49      echo -n "building the mpack utility...  "      printf "building the mpack utility...  "
50      if test ! -x "$MPACKDIR/mpack" ; then      if test ! -x "$MPACKDIR/mpack" ; then
51          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
52                echo
53              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
54              echo "  are you sure this program is being run in the correct "              echo "  are you sure this program is being run in the correct "
55              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"
56              exit 1              echo
57                HAVE_MPACK=f
58            fi
59            printf "building mpack...  "
60            if test "x$CC" = x ; then
61                export CC=cc
62          fi          fi
63          echo -n "building mpack...  "          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
         ( cd $MPACKDIR && ./configure && $MAKE ) > build_mpack.out 2>&1  
64          RETVAL=$?          RETVAL=$?
65          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
66              echo              echo
67              echo "Error building the mpack tools at: $MPACK_DIR"              echo "Error building the mpack tools at: $MPACK_DIR"
68              exit 1              echo
69                HAVE_MPACK=f
70            else
71                rm -f tr_build_mpack.out
72                HAVE_MPACK=t
73          fi          fi
74        else
75            HAVE_MPACK=t
76      fi      fi
77      echo "OK"      echo "OK"
78  }  }
79    
 compare_lines()  
 {  
     # use codelet to compare lines  
     if [ $verbose -gt 1 ]; then  
         cat tmp3.txt 1>&2  
     fi  
     return `./a.out < tmp3.txt`  
 }  
   
80  testoutput_for_prop()  testoutput_for_prop()
81  {  {
82      # testoutput_for_prop dir s1 label subdir      # testoutput_for_prop dir s1 label subdir extension
83      #      #
84      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt
85      #  using search strings s1 and text label      #  using search strings s1 and text label
# Line 81  testoutput_for_prop() Line 88  testoutput_for_prop()
88          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2
89      fi      fi
90      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/output.txt ]; then
91          grep "$2" $1/$4/output.txt | sed 's/.*=//' | nl > tmp1.txt          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt
92          lncnt=`wc -l tmp1.txt | awk '{print $1}' `          lncnt=`wc -l tmp1.txt | awk '{print $1}' `
93          if [ $lncnt -lt 3 ]; then          if [ $lncnt -lt 3 ]; then
94              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
# Line 94  testoutput_for_prop() Line 101  testoutput_for_prop()
101          return 99          return 99
102      fi      fi
103      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
104          echo testoutput_for_prop: grep "$2" $1/results/output.txt 1>&2          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2
105      fi      fi
106      grep "$2" $1/results/output.txt | sed 's/.*=//' | nl > tmp2.txt      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt
107      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncnt=`wc -l tmp2.txt | awk '{print $1}' `
108      if [ $lncnt -lt 3 ]; then      if [ $lncnt -lt 3 ]; then
109          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
# Line 111  testoutput_for_prop() Line 118  testoutput_for_prop()
118      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
119          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_for_prop: compare_lines 1>&2
120      fi      fi
121      compare_lines      if [ $verbose -gt 1 ]; then
122      digits_of_similarity=$?          cat tmp3.txt 1>&2
123        fi
124        echo "-1" >> tmp3.txt
125        # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
126        cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
127        digits_of_similarity=`./tmp_cmpnum < tmp4.txt`
128      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
129          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
130              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2
# Line 123  testoutput_for_prop() Line 135  testoutput_for_prop()
135              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2
136          fi          fi
137      fi      fi
138      rm tmp1.txt tmp2.txt tmp3.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
139            
140      return $digits_of_similarity      return $digits_of_similarity
141  }  }
# Line 143  dashnum() Line 155  dashnum()
155      done      done
156  }  }
157    
158    testoutput_ad()
159    {
160        grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $5}' > t05.txt
161        grep $3 $1/$2/output.txt_adm | awk '{print NR " " $5}' > t15.txt
162        grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $6}' > t06.txt
163        grep $3 $1/$2/output.txt_adm | awk '{print NR " " $6}' > t16.txt
164        join t05.txt t15.txt > t5.txt
165        join t06.txt t16.txt > t6.txt
166        echo "-1" >> t5.txt
167        echo "-1" >> t6.txt
168        digits_5=`./tmp_cmpnum < t5.txt`
169        digits_6=`./tmp_cmpnum < t6.txt`
170        dashnum $digits_5 $digits_6
171        rm -f t[01][56].txt t[56].txt
172    }
173    
174  testoutput()  testoutput()
175  {  {
176      # testoutput diretory subdir      # testoutput directory subdir extension
177      #      #
178      #  test output in "directory"      #  test output in "directory"
179        if test "x$ADM" = x ; then
180      if [ $debug -gt 0 ]; then          if [ $debug -gt 0 ]; then
181          echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2              echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2
182      fi          fi
183      testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2; cg2dres=$?          testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2 $3; cg2dres=$?
184      if [ $debug -gt 0 ]; then          if [ $debug -gt 0 ]; then
185          echo testoutput: cg2dres=$cg2dres 1>&2              echo testoutput: cg2dres=$cg2dres 1>&2
186            fi
187            testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2 $3; tmin=$?
188            testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2 $3; tmax=$?
189            testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2 $3; tmean=$?
190            testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2 $3; tsd=$?
191            testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2 $3; smin=$?
192            testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2 $3; smax=$?
193            testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2 $3; smean=$?
194            testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2 $3; ssd=$?
195            testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2 $3; umin=$?
196            testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2 $3; umax=$?
197            testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2 $3; umean=$?
198            testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2 $3; usd=$?
199            testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2 $3; vmin=$?
200            testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2 $3; vmax=$?
201            testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2 $3; vmean=$?
202            testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2 $3; vsd=$?
203            dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \
204                $umin $umax $umean $usd $vmin $vmax $vmean $vsd
205        else
206            testoutput_ad $1 $2 "precision_grdchk_result"
207      fi      fi
       
     testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2; tmin=$?  
     testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2; tmax=$?  
     testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2; tmean=$?  
     testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2; tsd=$?  
     testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2; smin=$?  
     testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2; smax=$?  
     testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2; smean=$?  
     testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2; ssd=$?  
     testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2; umin=$?  
     testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2; umax=$?  
     testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2; umean=$?  
     testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2; usd=$?  
     testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2; vmin=$?  
     testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2; vmax=$?  
     testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2; vmean=$?  
     testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2; vsd=$?  
       
     dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \  
         $umin $umax $umean $usd $vmin $vmax $vmean $vsd  
208  }  }
209    
210  genmakemodel()  genmakemodel()
# Line 184  genmakemodel() Line 213  genmakemodel()
213      if test "x$NOGENMAKE" = xt ; then      if test "x$NOGENMAKE" = xt ; then
214          echo "genmake skipped!"          echo "genmake skipped!"
215      else      else
216          GENMAKE2="$BASH ../../../tools/genmake2"          if test "x$BASH" = x ; then
217                GENMAKE2="../../../tools/genmake2"
218            else
219                GENMAKE2="$BASH ../../../tools/genmake2 -bash $BASH"
220            fi
221          (          (
222              cd $1;              cd $1;
223              command="$GENMAKE2  -ds -m $MAKE --mods=../code"              command="$GENMAKE2  -ds -m $MAKE"
224                if test "x$ADM" = x ; then
225                    command="$command --mods=../code"
226                else
227                    command="$command --mods=../code_ad"
228                    command="$command -adof=../../../tools/adjoint_options/adjoint_staf"
229                fi
230              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
231                  command="$command --optfile=$OPTFILE"                  command="$command --optfile=$OPTFILE"
                 # echo "  command=\"$command\""  
232              fi              fi
233              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
234                  command="$command -ieee"                  command="$command -ieee"
235              fi              fi
             # echo "command: \"$command\""  
236              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
237              $command > make.log 2>&1              $command > make.log 2>&1
238              RETVAL=$?              RETVAL=$?
239              for i in genmake_state genmake_optfile genmake_local Makefile ; do              #  Reduce the size of the testing emails!
240                  if test -r $i ; then              #  cp Makefile $CDIR
                     cp $i $CDIR  
                 fi  
             done  
241              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
242                  tail make.log                  tail make.log
243                  echo "genmakemodel: genmake failed" 1>&2                  echo "genmakemodel: genmake failed" 1>&2
244                  cp make.log $CDIR                  cp genmake_* make.log $CDIR
245                  return 1                  return 1
246              else              else
247                  echo "succesful" 1>&2                  echo "successful" 1>&2
248              fi              fi
249          )          )
250      fi      fi
# Line 238  makeclean() Line 272  makeclean()
272                      return 1                      return 1
273                  fi                  fi
274              fi              fi
275              echo succesful 1>&2              echo successful 1>&2
276              exit 0              exit 0
277          )          )
278      fi      fi
# Line 261  makedependmodel() Line 295  makedependmodel()
295                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
296                  return 1                  return 1
297              else              else
298                  echo succesful 1>&2                  echo successful 1>&2
299              fi              fi
300          )          )
301      fi      fi
# Line 274  makemodel() Line 308  makemodel()
308          cd $1;          cd $1;
309          if test -r Makefile ; then          if test -r Makefile ; then
310              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
311              $MAKE >> make.log 2>&1              if test "x$ADM" = x ; then
312                    if test "x$JOBS" = x ; then
313                        $MAKE >> make.log 2>&1
314                    else
315                        $MAKE -j $JOBS >> make.log 2>&1
316                    fi
317                else
318                    $MAKE adall >> make.log 2>&1
319                fi
320              RETVAL=$?              RETVAL=$?
321              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
322                  tail make.log                  tail make.log
# Line 282  makemodel() Line 324  makemodel()
324                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
325                  return 1                  return 1
326              else              else
327                  echo succesful 1>&2                  echo successful 1>&2
328              fi              fi
329          fi          fi
330      )      )
331  }  }
332    
333    symlink_mpifiles()
334    {
335        # Put special links so that MPI specific files are used
336        # This MUST be invoked between makeclean and makelinks because
337        # the Makefile will link to non-mpi files by default
338    
339        dir=$1
340        code_dir=$2
341        BUILD_DIR=$dir/$3
342        CODE_DIR=$dir/$code_dir
343        
344        # These are files that should replace their counter-part when using -mpi
345        MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`
346    
347        #  Is this an MPI run?
348        if test "x$MPI" = xt ; then
349            # YES: We symbolically link these files to the build
350            # dir so long as there is no real file in place
351            for ii in $MPI_FILES ; do
352                i=`echo $ii | sed 's:^\./::'`
353                name=`echo $i | sed 's:_mpi::' `
354                cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1
355                RETVAL=$?
356                if test "x$RETVAL" != x0 ; then
357                    if ! test -f $BUILD_DIR/$i ; then
358                        #echo Linking $name to $i
359                        (cd $BUILD_DIR; ln -sf ../$code_dir/$i $name)
360                    fi
361                fi
362            done
363        else
364            # NO: We undo any _mpi symbolically linked files
365            for ii in $MPI_FILES ; do
366                i=`echo $ii | sed 's:^\./::'`
367                name=`echo $i | sed 's:_mpi::' `
368                if test -L $BUILD_DIR/$name ; then
369                    cmp $BUILD_DIR/$name "../$code_dir/$name"_mpi > /dev/null 2>&1
370                    RETVAL=$?
371                    if test "x$RETVAL" = x0 ; then
372                        #echo Un-linking $name from $linktarg
373                        rm -f $BUILD_DIR/$name
374                    fi
375                fi
376            done
377        fi
378        
379    }
380    
381  linkdata()  linkdata()
382  {  {
383      # linkdata flag      # linkdata flag
384      #      #
385      # symbolically link data files to run directory      # symbolically link data files to run directory
386      if [ $1 -ne 0 ]; then      if test "x$1" = x1 ; then
387          ( cd $2 ;  ln -sf ../input/* . )          (
388                cd $2
389                if test "x$ADM" = x ; then
390                    files=`( cd ../input ; ls -1 | grep -v CVS )`
391                    for i in $files ; do
392                        if test ! -d "../input/"$i ; then
393                            ln -sf "../input/"$i $i
394                        fi
395                    done
396                else
397                    files=`( cd ../input ; ls -1 *.bin | grep -v CVS )`
398                    for i in $files ; do
399                        if test ! -d "../input/"$i ; then
400                            ln -sf "../input/"$i $i
401                        fi
402                    done
403                    files=`( cd ../input_ad ; ls -1 | grep -v CVS )`
404                    for i in $files ; do
405                        if test ! -d "../input_ad/"$i ; then
406                            ln -sf "../input_ad/"$i $i
407                        fi
408                    done
409                fi
410            )
411      fi      fi
412  }  }
413    
# Line 302  runmodel() Line 415  runmodel()
415  {  {
416      # runmodel directory      # runmodel directory
417      #      #
418      #  runs "$COMMAND" in "directory"      #  runs "$COMMAND in "directory"
419      #  (where "$COMMAND" is relative to "directory")      #  (where "$COMMAND" is relative to "directory")
420      (      (
421          cd $1          cd $1
422          printf 'runmodel: ' 1>&2          printf 'runmodel ... ' 1>&2
423          # make output.txt          # make output.txt
424          $COMMAND          echo
425            # echo "COMMAND='$COMMAND'"
426            # echo "pwd='"`pwd`"'"
427            ( eval $COMMAND ) >> run.log 2>&1
428          RETVAL=$?          RETVAL=$?
429          if test "x$RETVAL" = x0 ; then          if test "x$RETVAL" = x0 ; then
430              cp output.txt $CDIR"/output.txt"              echo successful 1>&2
431                # === Reduce the size of the testing emails!
432                # if test "x$ADM" = x ; then
433                #   cp output.txt $CDIR"/output.txt"
434                # else
435                #   cp output.txt_adm $CDIR"/output.txt_adm"
436                # fi
437              return 0              return 0
438          else          else
439                tail run.log
440                echo failed 1>&2
441                cp run.log $CDIR"/run.log"
442              return 1              return 1
443          fi          fi
444      )      )
# Line 323  createcodelet() Line 448  createcodelet()
448  {  {
449      # create codelet for comparing model output      # create codelet for comparing model output
450    
451      echo -n "creating the comparison code...  "      printf "creating the comparison code...  "
452      cat > tmp_cmpnum.f <<EOFA      cat > tmp_cmpnum.c <<EOF
453        program cmpnum  #include <stdio.h>
454        implicit none  #include <math.h>
455        real*8 a,b,diff  int main( int argc, char** argv )  {
456        integer linnum,best    int linnum,best,lncnt;
457        best=-16    double a,b,diff;
458    99  read(*,*,end=70,err=60) linnum,a,b    best = -16;
459        diff=0.5*(abs(a)+abs(b))    lncnt = 0;
460  c     print *,a,b,diff,abs(a-b)/diff    while( 1 & (lncnt+=1) < 999 )  {
461        if (diff.gt.1.e-12) then      scanf("%d", &linnum);
462          diff=abs(a-b)/diff      if (linnum == -1)  break;
463          if (diff.gt.0.) then      scanf("%lf", &a);  scanf("%lf", &b);
464  c         print *,int(log10(diff)),diff      diff = 0.5*(fabs(a)+fabs(b));
465            linnum=int(log10(diff))      if (diff > 1.e-12) {
466            best=max(best,linnum)        diff=fabs(a-b)/diff;
467          endif        if (diff > 0.0) {
468        else          linnum = (int)log10(diff);
469          if (best.eq.-16.and.diff.ne.0.) best=-22          best = (best > linnum) ? best : linnum;
470        endif        }
471        goto 99        else {
472    60  stop 'cmpnum: An error occured reading a,b'          if (best == -16 && diff != 0)  best = -22;
473    70  print *,-best        }
474        end      }
475  EOFA    }
476      if (lncnt == 999) best=-29;
477      printf("%d\n", -best);
478      return 0;
479    }
480    EOF
481        cc -o tmp_cmpnum tmp_cmpnum.c -lm
482    
483      f77 tmp_cmpnum.f      if [ -x ./tmp_cmpnum ]; then
     if [ -x ./a.out ]; then  
484          echo "OK"          echo "OK"
485          return 0          return 0
486      else      else
487          echo          echo
488          echo "createcodelet: failed to compile codelet"          echo "ERROR: failed to compile comparison code"
489          exit 1          exit 1
490      fi      fi
491  }  }
# Line 415  scandirs() Line 545  scandirs()
545    
546    
547  ###############################################################################  ###############################################################################
 ###############################################################################  
 ###############################################################################  
548    
549    
550  #  Default properties  #  Default properties
# Line 426  clean=0 Line 554  clean=0
554  expts=''  expts=''
555  # ieee=1  # ieee=1
556    
557  IEEE=  IEEE=true
558  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
559      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
560  fi  fi
# Line 443  OPTFILE=NONE Line 571  OPTFILE=NONE
571  ADDRESSES=  ADDRESSES=
572  TESTDIRS=  TESTDIRS=
573  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
574    HAVE_MPACK=
575  MPACK="$MPACKDIR/mpack"  MPACK="$MPACKDIR/mpack"
576  COMMAND="make output.txt"  COMMAND=
577  MAKE=make  MAKE=make
578    JOBS=
579  MPI=f  MPI=f
580    DELDIR=
581    
582  echo -n "parsing options...  "  ADM=
583    
584    printf "parsing options...  "
585    
586  ac_prev=  ac_prev=
587  for ac_option ; do  for ac_option ; do
# Line 497  for ac_option ; do Line 630  for ac_option ; do
630          -make=* | --make=*)          -make=* | --make=*)
631              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
632    
633            -j) ac_prev=JOBS ;;
634            -j=*) JOBS=$ac_optarg ;;
635    
636          -clean | --clean)          -clean | --clean)
637              CLEANUP=t ;;              CLEANUP=t ;;
638    
# Line 509  for ac_option ; do Line 645  for ac_option ; do
645          -nodepend | --nodepend | -nd | --nd)          -nodepend | --nodepend | -nd | --nd)
646              NODEPEND=t ;;              NODEPEND=t ;;
647    
648          -mpi) MPI=true ;;          -mpi) MPI=t ;;
649    
650            -adm | -ad) ADM=t ;;
651    
652          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
653          -noieee) IEEE= ;;          -noieee) IEEE= ;;
# Line 518  for ac_option ; do Line 656  for ac_option ; do
656          -debug) debug=1 ;;          -debug) debug=1 ;;
657          -quiet) verbose=0 ;;          -quiet) verbose=0 ;;
658    
659            -deldir | -dd) DELDIR=t ;;
660    
661          -*)          -*)
662              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
663              usage              usage
# Line 546  if test "x$OPTFILE" = xNONE -a "x$MITGCM Line 686  if test "x$OPTFILE" = xNONE -a "x$MITGCM
686      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
687  fi  fi
688    
689    if test "x$ADM" = xt -a "x$COMMAND" = x ; then
690        COMMAND="./mitgcmuv_ad > output.txt_adm 2>&1"
691    fi
692    
693    if test "x$COMMAND" = x ; then
694        COMMAND="$MAKE output.txt"
695    fi
696    
697  echo "OK"  echo "OK"
698    
699  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
700  createcodelet  createcodelet
701    
702  #  build the mpack utility  #  build the mpack utility
703  build_mpack  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
704        echo "skipping mpack build"
705    else
706        build_mpack
707    fi
708    
709  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
710  MACH=`hostname`  MACH=`hostname`
711  UNAMEA=`uname -a`  UNAMEA=`uname -a`
712  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
713  BASE=$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
714  DNUM=0  DNUM=0
715  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
716  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 568  done Line 720  done
720  mkdir $DRESULTS  mkdir $DRESULTS
721  RETVAL=$?  RETVAL=$?
722  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
723      echo "Error: can't create results directory \"./$DRESULTS\""      echo "ERROR: Can't create results directory \"./$DRESULTS\""
724      exit 1      exit 1
725  fi  fi
726  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
727  date > $SUMMARY  printf "Start time:  " >> $SUMMARY
728  cat << EOF >> $SUMMARY  start_date=`date`
729                  T           S           U           V  echo $start_date > $SUMMARY
 G D M    c        m  s        m  s        m  s        m  s  
 E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .  
 N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d  
 2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .  
   
 EOF  
   
 NDIR=0  
730    
731  of_path=  of_path=
732  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 596  if test "x$OPTFILE" != xNONE ; then Line 740  if test "x$OPTFILE" != xNONE ; then
740          fi          fi
741          file=${OPTFILE##*/}          file=${OPTFILE##*/}
742          OPTFILE=$of_path/$file          OPTFILE=$of_path/$file
743            cp $OPTFILE $DRESULTS
744            echo >> $SUMMARY
745            echo "  OPTFILE=$OPTFILE" >> $SUMMARY
746      else      else
747          echo          echo | tee $SUMMARY
748          echo "WARNING: can't read OPTFILE=\"$OPTFILE\" but will try to use it..."          echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY
749            exit 1
750      fi      fi
751    else
752        echo >> $SUMMARY
753        echo "No \"OPTFILE\" was explicitly specified by testreport," >> $SUMMARY
754        echo "   so the genmake default will be used." >> $SUMMARY
755  fi  fi
756  echo  echo
 echo "OPTFILE=$OPTFILE" >> $SUMMARY  
757  echo >> $SUMMARY  echo >> $SUMMARY
758    if test "x$ADM" = x ; then
759        cat << EOF | tee -a $SUMMARY
760                    T           S           U           V
761    G D M    c        m  s        m  s        m  s        m  s
762    E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .
763    N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d
764    2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .
765    
766    EOF
767    else
768        echo "ADJOINT=true" >> $SUMMARY
769        echo >> $SUMMARY
770        cat << EOF | tee -a $SUMMARY
771    G D M    C  G
772    E p a R  o  r
773    N n k u  s  a
774    2 d e n  t  d
775    
776    EOF
777    fi
778    
779  #  ...and each test directory...  #  ...and each test directory...
780  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
# Line 621  for dir in $TESTDIRS ; do Line 792  for dir in $TESTDIRS ; do
792    
793      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
794      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
795      if test ! -r $dir"/results/output.txt" ; then      fout=
796          echo "can't read \"$dir/results/output.txt\" -- skipping $dir"      if test "x$ADM" = x ; then
797            fout=$dir"/results/output.txt"
798        else
799            fout=$dir"/results_ad/output.txt_adm"
800        fi
801        if test ! -r $fout ; then
802            echo "can't read \"$fout\" -- skipping $dir"
803            continue
804        fi
805    
806        builddir="input"
807        rundir="input"
808        use_seperate_build=0
809        if test -d $dir/build -a -r $dir/build ; then
810            builddir="build"
811            rundir="build"
812            use_seperate_build=1
813            linkdata $use_seperate_build $dir/$rundir
814        fi
815        
816        #  Check whether there are "extra runs" for this testdir
817        extra_runs=
818        if test "x$ADM" = x -a "x$use_seperate_build" = x1 ; then
819            ex_run_dirs=`( cd $dir ; echo input.* )`
820            echo "ex_run_dirs='$ex_run_dirs'"
821            for exd in $ex_run_dirs ; do
822                name=`echo $exd | sed -e 's/input.//g'`
823                outf="$dir/results/output.txt.$name"
824                if test -f $outf -a -r $outf ; then
825                    extra_runs="$extra_runs $name"
826                fi
827            done
828        fi
829    
830        if test "x$ADM" = x ; then
831            code_dir=code
832            CODE_DIR=$dir/code
833        else
834            code_dir=code_ad
835            CODE_DIR=$dir/code_ad
836        fi
837        BUILD_DIR=$dir/$builddir
838    
839        if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
840            echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
841          continue          continue
842      fi      fi
843    
# Line 633  for dir in $TESTDIRS ; do Line 848  for dir in $TESTDIRS ; do
848      unset genmake makedepend make run      unset genmake makedepend make run
849      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'
850    
     if [ -r $dir/build ]; then  
         seperatebuilddir=1  
         builddir=build  
         rundir=build  
         ( cd $dir/build; ln -sf ../input/* . )  
     else  
         seperatebuilddir=0  
         builddir=input  
         rundir=input  
     fi  
       
     CODE_DIR=$dir/code  
     BUILD_DIR=$dir/$builddir  
     MPI_FILES="CPP_EEOPTIONS.h_mpi SIZE.h_mpi"  
     NOMPI_FILES="CPP_EEOPTIONS.h_nompi SIZE.h_nompi"  
   
     #  Is this an MPI run?  
     if test "x$MPI" = xt ; then  
         FILES=$MPI_FILES  
         endings="_mpi"  
     else  
         FILES=$NOMPI_FILES  
         endings="_nompi"  
     fi  
       
     #  Check to see that we have the files  
     have_files=t  
     for i in $FILES ; do  
         if test ! -r $CODE_DIR/$i ; then  
             echo "Warning: can't read file $CODE_DIR/$i"  
             have_files=f  
         fi  
     done  
     if test "x$have_files" != xt -a "x$MPI" = xt ; then  
         echo "Skipping $dir due to lack of input files (see above warning)"  
         continue  
     fi  
       
     #  If we have the $FILES and they differ, copy the $FILES to $BUILD_DIR  
     if test "x$have_files" = xt ; then  
         for i in $FILES ; do  
             sstr="s|$endings||"  
             name=`echo $i | sed -e $sstr `  
             cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1  
             RETVAL=$?  
             if test "x$RETVAL" != x0 ; then  
                 cp $CODE_DIR/$i $BUILD_DIR/$name  
             fi  
         done  
     fi  
       
851      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
852      CDIR=$DRESULTS"/"$DRESULTS"_"$NDIR      rel_CDIR=$DRESULTS"/"$dir
853      mkdir $CDIR      mkdir $rel_CDIR
854      CDIR=`pwd`"/$CDIR"      CDIR=`pwd`"/$rel_CDIR"
855            
856      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
857          makeclean $dir/$builddir          makeclean $dir/$builddir
858      else      else
859          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
860              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
861                && symlink_mpifiles $dir $code_dir $builddir \
862              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
863              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
864              && linkdata $seperatebuilddir $dir/$rundir \              && linkdata $use_seperate_build $dir/$rundir \
865              && runmodel $dir/$builddir && run=Y \              && runmodel $dir/$rundir && run=Y \
866              && results=`testoutput $dir $rundir`              && results=`testoutput $dir $rundir`
867      fi      fi
868            
869      echo      echo
870      formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \      if test "x$ADM" = x ; then
871          ${run:-N} $results          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
872      echo          echo
873      formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \          echo "$fres" >> $SUMMARY
874          ${run:-N} $results >> $SUMMARY          echo "fresults='$fres'" > $CDIR"/summary.txt"
875      echo "fresults='" > $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
876      formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
877          ${run:-N} $results >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
878      echo "'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
879      echo "MACH='$MACH'" >> $CDIR"/summary.txt"  
880      echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          OLD_COMMAND=$COMMAND
881      echo "DATE='$DATE'" >> $CDIR"/summary.txt"          COMMAND="./mitgcmuv > output.txt"
882      echo "tdir='$dir'" >> $CDIR"/summary.txt"          for ex in $extra_runs ; do
883                test -e "$dir/tr_run.$ex" && rm -rf "$dir/tr_run.$ex"
884                mkdir "$dir/tr_run.$ex"
885                links=`( cd "$dir/input" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`
886                (
887                    cd "$dir/tr_run.$ex"
888                    for i in $links; do
889                        ln -s ../input/$i $i
890                    done
891                )
892                links=`( cd "$dir/input.$ex" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`
893                (
894                    cd "$dir/tr_run.$ex"
895                    for i in $links; do
896                        test -e $i  &&  rm -f $i
897                        ln -s ../input.$ex/$i $i
898                    done
899                    ln -s ../$builddir/mitgcmuv mitgcmuv
900                )
901                runmodel $dir/tr_run.$ex && run=Y \
902                    && results=`testoutput $dir tr_run.$ex "."$ex`
903                fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
904                fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
905                fres="$fres.$ex"
906                echo
907                echo "$fres" >> $SUMMARY
908                echo "fresults='$fres'" > $CDIR"/summary.txt"
909                echo "MACH='$MACH'" >> $CDIR"/summary.txt"
910                echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
911                echo "DATE='$DATE'" >> $CDIR"/summary.txt"
912                echo "tdir='$dir'" >> $CDIR"/summary.txt"
913            done
914            COMMAND=$OLD_COMMAND
915        else
916            fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
917            fres=$fres"$results   $dir"
918            echo
919            echo "$fres" >> $SUMMARY
920            echo "fresults='$fres'" > $CDIR"/summary.txt"
921            echo "MACH='$MACH'" >> $CDIR"/summary.txt"
922            echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
923            echo "DATE='$DATE'" >> $CDIR"/summary.txt"
924            echo "tdir='$dir'" >> $CDIR"/summary.txt"
925        fi
926            
927      (      echo "-------------------------------------------------------------------------------"
         cd $DRESULTS  
         tar -cf $NDIR".tar" $DRESULTS"_"$NDIR > /dev/null 2>&1  
         gzip $NDIR".tar"  
     )  
928            
929      if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  done
930          echo "No mail sent"  
931      else  printf "Start time:  " >> $SUMMARY
932          $MPACK -s MITgcm-test -m 1000000 $DRESULTS"/"$NDIR".tar.gz" $ADDRESSES  echo $start_date >> $SUMMARY
933    printf "End time:    " >> $SUMMARY
934    date >> $SUMMARY
935    
936    #  If addresses were supplied and mpack built successfully, then try
937    #  to send email using mpack.
938    if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
939        echo "No results email was sent."
940    else
941        if test "x$HAVE_MPACK" = xt ; then
942            tar -cf $DRESULTS".tar" $DRESULTS > /dev/null 2>&1 \
943                && gzip $DRESULTS".tar" \
944                && $MPACK -s MITgcm-test -m 3555000 $DRESULTS".tar.gz" $ADDRESSES
945          RETVAL=$?          RETVAL=$?
946          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
947              echo "Warning: \"$MPACK\" failed -- please contact <edhill@mitgcm.org>"              echo
948                echo "Warning: The tar, gzip, & mpack step failed.  Please send email"
949                echo "  to <MITgcm-support@mitgcm.org> for help.  You may copy the "
950                echo "  summary of results from the directory \"$DRESULTS\"."
951                echo
952          else          else
953              rm -f $DRESULTS"/"$NDIR".tar*"              echo
954                echo "An email containing results was sent to the following addresses:"
955                echo "  \"$ADDRESSES\""
956                echo
957          fi          fi
958            test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"
959            test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"
960      fi      fi
961    fi
962    
963      echo "-------------------------------------------------------------------------------"  # rm -f tmp_cmpnum.f a.out
964        rm -f tmp_cmpnum.c tmp_cmpnum
     NDIR=$(( $NDIR + 1 ))  
       
 done  
965    
966  rm tmp_cmpnum.f a.out  if test "x$CLEANUP" != xt ; then
967        cat $SUMMARY
968        if test -e tr_out.txt ; then
969            mv tr_out.txt tr_out.txt.old
970        fi
971        cat $SUMMARY > tr_out.txt
972    fi
973    
974  cat $SUMMARY  if test "x$DELDIR" = xt ; then
975        rm -rf $DRESULTS
976    fi
977    

Legend:
Removed from v.1.11  
changed lines
  Added in v.1.45

  ViewVC Help
Powered by ViewVC 1.1.22